<?php

/**
 * Plugin Name: Json Template Plugin
 * Description: Kickstart Starter Package for the feature to create the page with JSON OR Everyboard
 * Author: Naviga Web Team
 * Version: 0.0.5
 * Network: true
 * Author URI: https://www.navigaglobal.com/web/
 */
use Everyware\Plugin\SettingsParameters\SettingsParameter;

require(WP_PLUGIN_DIR.'/everyware-plugin-json-template/json-file-editor-plugin.php');
 
function add_json_template_meta_box() {
    add_meta_box(
        'json_template_meta_box',
        'Json Template List',
        'render_json_template_meta_box',
        ['page'],
        'side',
    );
}
add_action('add_meta_boxes', 'add_json_template_meta_box');

// Rendering Meta Box Content
function render_json_template_meta_box($post) {
    // Retrieve existing value from the database
    $selected_value = get_post_meta($post->ID, '_json_template_list', true);


    //Get comma seperate json template list from setting parameter and create an array of that list 
    $jsonTemplateNameList = SettingsParameter::getValue('json-template-list');
    $jsonTemplateNameListArr = $jsonTemplateNameList ? explode(",", $jsonTemplateNameList) : "";
    // Dropdown options
    if(!empty($jsonTemplateNameListArr))
    {
        $dropdown_options = array("" => "Select");
        foreach($jsonTemplateNameListArr as $listArr)
        {
            $dropdown_options[trim($listArr)] = trim($listArr);
        }

    } 
    else
    {
        /***Get all JSON Files from the nav-site-builder-json folder by the glob() function */
        $files_lists = str_replace(".json", "", str_replace( get_theme_file_path("/nav-site-builder-json/"), '', glob(get_theme_file_path("/nav-site-builder-json")."/*.json")));
        if(!empty($files_lists))
        {
            // Dropdown options
            $dropdown_options = array("" => "Select");
            foreach($files_lists as $listArr)
            {
                $dropdown_options[trim($listArr)] = trim($listArr);
            }
        } else {
            $dropdown_options = array(
                '' => 'Select',
            );
        }
    }


    // Output the dropdown HTML
    echo '<label for="json_template_list">Template List:</label>';
    echo '<select name="json_template_list" id="json_template_list">';
    foreach ($dropdown_options as $value => $label) {
        echo '<option value="' . esc_attr($value) . '" ' . selected($selected_value, $value, false) . '>' . esc_html($label) . '</option>';
    }
    echo '</select>';
}

// Saving Meta Box Data
function save_book_meta_data($post_id) {
    if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE) {
        return;
    }

    if (!current_user_can('edit_post', $post_id)) {
        return;
    }

    if (isset($_POST['json_template_list'])) {
        update_post_meta($post_id, '_json_template_list', sanitize_text_field($_POST['json_template_list']));
    }
}
add_action('save_post', 'save_book_meta_data');


add_action('admin_head', 'toggle_value_of_board_id_json_template_on_selection');
function toggle_value_of_board_id_json_template_on_selection() {
    echo '<script type="text/javascript">
    jQuery(document).ready(function(){
        jQuery("#json_template_list").change(function(){
            var template_list = jQuery("#json_template_list").val();
            if(template_list != "null")
            {
                jQuery("#everyboard_id").val("");
            }
        });
        jQuery("#everyboard_id").change(function(){
            var board_id = jQuery("#everyboard_id").val();
            if(board_id > 0)
            {
                jQuery("#json_template_list").val("");
            }
        });
    });
  </script>';
}

use Carbon\Carbon;
function humanTimeDiff($date)
{
    $carbonDate = Carbon::parse($date);
    return $carbonDate->diffForHumans();
}