<?php

use EuKit\Base\Parts\NewsMLArticle;
use EuKit\Base\ViewModels\Teaser;
use Infomaker\Everyware\Base\OpenContent\OpenContentProvider;


/**
 * To find the selection of json template list
 */
$getPostMetaValues = get_post_meta( get_the_ID());
$json_template_list = $getPostMetaValues['_json_template_list'][0] ?? "";


/* Get site builder settings and uri parts */
//require get_theme_file_path('/inc/nav-site-builder/parameters.php');

/*
    2022029 - MCD
    OC Query Functions moved to separate php required files for Organization of additional queries
*/
require WP_PLUGIN_DIR.'/everyware-plugin-json-template/nav-site-builder/query_functions/returnArticleLists.php';
require WP_PLUGIN_DIR.'/everyware-plugin-json-template/nav-site-builder/query_functions/returnAuthorData.php';
require WP_PLUGIN_DIR.'/everyware-plugin-json-template/nav-site-builder/query_functions/returnStaffLists.php';
require WP_PLUGIN_DIR.'/everyware-plugin-json-template/nav-site-builder/query_functions/returnGA_MostReadList.php';
require WP_PLUGIN_DIR.'/everyware-plugin-json-template/nav-site-builder/query_functions/return_Query_With_NoDuplicates.php';
require WP_PLUGIN_DIR.'/everyware-plugin-json-template/nav-site-builder/query_functions/returnFullArticleLists.php';

$conceptJSONFilePath = get_theme_file_path('/nav-site-builder-json/' . $json_template_list.'.json');
$conceptJSON = file_get_contents($conceptJSONFilePath);




/* Replace dashes from url with spaces */
/* Change First letter in each word to upper case */
/* Replace Concept Name in JSON */
$conceptNameFilter = str_replace('-', ' ', $conceptNameFilter);
$conceptNameFilter = ucwords($conceptNameFilter);
$conceptJSON = str_replace('{queryparam-conceptname}', $conceptNameFilter, $conceptJSON);
if (isset($subconceptNameFilter)) {
    $subconceptNameFilter = str_replace('-', ' ', $subconceptNameFilter);
    $subconceptNameFilter = ucwords($subconceptNameFilter);
    $conceptJSON = str_replace('{queryparam-subconceptname}', $subconceptNameFilter, $conceptJSON);
}

/* Replace Page Num in JSON */
$conceptJSON = str_replace('{pagenum}', $pageNum, $conceptJSON);

/* Check Concept Type Value and adjust query based on value */
if ($conceptTypeFilter == 'section') {
    $conceptJSON = str_replace('{queryparam-concepttype}', 'SectionName', $conceptJSON);
} elseif ($conceptTypeFilter == 'category') {
    $conceptJSON = str_replace('{queryparam-concepttype}', 'CategoryName', $conceptJSON);
} else {
    $conceptJSON = str_replace('{queryparam-concepttype}', 'ArticleTags', $conceptJSON);
}

if (isset($subconceptTypeFilter)) {
    if ($subconceptTypeFilter == 'section') {
        $conceptJSON = str_replace('{queryparam-subconcepttype}', 'SectionName', $conceptJSON);
    } elseif ($conceptTypeFilter2 == 'category') {
        $conceptJSON = str_replace('{queryparam-subconcepttype}', 'CategoryName', $conceptJSON);
    } else {
        $conceptJSON = str_replace('{queryparam-subconcepttype}', 'ArticleTags', $conceptJSON);
    }
}

/* Decode JSON File */
$conceptJSONArray = json_decode($conceptJSON, true);
/* Set pageheadline */
$pageHeadline = $conceptNameFilter;

/* Create/Set No Duplicates Article Array */
if (isset($GLOBALS['used_uuids'])) {
    $noDuplicatesArray = $GLOBALS['used_uuids'];
} else {
    $noDuplicatesArray = array();
}

$find_Concept_Specific_Settings = $conceptNameFilter;
/* Find Concept specific section lists */
foreach ($conceptJSONArray as $key => $value) {
    if ($key == $find_Concept_Specific_Settings) {
        /*Build Lists Array using conceptNameFilter */
        if (isset($conceptJSONArray[$find_Concept_Specific_Settings]['pageheadline'])) {
            $pageHeadline = $conceptJSONArray[$find_Concept_Specific_Settings]['pageheadline'];
        }
        if (isset($conceptJSONArray[$find_Concept_Specific_Settings]['pageheaderid'])) {
            $pageheaderid = $conceptJSONArray[$find_Concept_Specific_Settings]['pageheaderid'];
        }
        $leftListsArray = $conceptJSONArray[$find_Concept_Specific_Settings]['left-lists'];
        if (isset($conceptJSONArray[$find_Concept_Specific_Settings]['right-lists'])) {
            $rightListsArray = $conceptJSONArray[$find_Concept_Specific_Settings]['right-lists'];
        } else {
            $rightListsArray = $conceptJSONArray['section_default']['right-lists'];
        }

        /* Use custom split */
        if (isset($conceptJSONArray[$find_Concept_Specific_Settings]['split'])) {
            $customPageSplit = $conceptJSONArray[$find_Concept_Specific_Settings]['split'];
            $customPageSplit = explode(",", $customPageSplit);
            if (isset($customPageSplit[1])) {
                $leftSplit = $customPageSplit[0];
                $rightSplit = $customPageSplit[1];
                $leftWidth = "width:" . $leftSplit . "%;";
                $rightWidth = "width:" . $rightSplit . "%;";
            } else {
                $leftWidth = "width:100%;";
                $rightWidth = "display: none;";
            }
        } else {
            $defaultPageSplit = $conceptJSONArray['section_default']['split'];
            $defaultPageSplit = explode(",", $defaultPageSplit);
            if (isset($defaultPageSplit[1])) {
                $leftSplit = $defaultPageSplit[0];
                $rightSplit = $defaultPageSplit[1];
                $leftWidth = "width:" . $leftSplit . "%;";
                $rightWidth = "width:" . $rightSplit . "%;";
            } else {
                $leftWidth = "width:100%;";
                $rightWidth = "display: none;";
            }
        }
    }
}

/*Build Lists Array using default name settings */
require WP_PLUGIN_DIR.'/everyware-plugin-json-template/nav-site-builder/default-name-settings.php';

/* Build Left Lists Array */
$leftListsCounter = 1;
foreach ($leftListsArray as $list) {
    ${'leftLists' . $leftListsCounter} = array();
    /* Check for adspot type */
    if (isset($list['type']) and $list['type'] == 'adspot') {
        ${'leftLists' . $leftListsCounter}['type'] = $list['type'] ?? null;
        ${'leftLists' . $leftListsCounter}['width'] = $list['width'] ?? null;
        ${'leftLists' . $leftListsCounter}['adcode'] = $list['adcode'] ?? null;
        ${'leftLists' . $leftListsCounter}['provider'] = $list['provider'] ?? null;
        /* 2023-03-22 ERD: Handle sidebar rendering */
    } elseif (isset($list['type']) and $list['type'] == 'render-sidebar') {
        ${'leftLists' . $leftListsCounter} = $list;
        /* Check for column type */
    } elseif (isset($list['type']) and $list['type'] == 'column') {
        ${'leftLists' . $leftListsCounter}['type'] = $list['type'] ?? null;
        ${'leftLists' . $leftListsCounter}['headline'] = $list['headline'] ?? null;
        ${'leftLists' . $leftListsCounter}['listurl'] = $list['listurl'] ?? null;
        ${'leftLists' . $leftListsCounter}['readmore'] = $list['readmore'] ?? null;
        ${'leftLists' . $leftListsCounter}['format'] = $list['format'] ?? null;
        ${'leftLists' . $leftListsCounter}['articles'] = returnArticleLists($list['query'], $list['count'], $list['start'])['articles'];
        /* Insert columnist image uuid into article array */
        for ($a = 0; $a < sizeof(${'leftLists' . $leftListsCounter}['articles']); $a++) {
            $authors = ${'leftLists' . $leftListsCounter}['articles'][$a]['authors'];
            foreach ($authors as $author) {
                $authorquery = 'uuid:' . $author['uuid'];
                $authordata = returnAuthordata($authorquery);
                ${'leftLists' . $leftListsCounter}['articles'][$a]['author_imageuuid'] = $authordata[0]['image_uuids'][0];
            }
        }
        /* Check for mostread type */
    } elseif (isset($list['type']) and $list['type'] == 'mostread') {
        ${'leftLists' . $leftListsCounter}['type'] = $list['type'] ?? null;
        ${'leftLists' . $leftListsCounter}['headline'] = $list['headline'] ?? null;
        ${'leftLists' . $leftListsCounter}['listurl'] = $list['listurl'] ?? null;
        ${'leftLists' . $leftListsCounter}['readmore'] = $list['readmore'] ?? null;
        ${'leftLists' . $leftListsCounter}['count'] = $list['count'] ?? null;
        ${'leftLists' . $leftListsCounter}['start'] = $list['start'] ?? null;
        ${'leftLists' . $leftListsCounter}['view_id'] = $list['view_id'] ?? null;
        ${'leftLists' . $leftListsCounter}['template'] = $list['template'] ?? null;
        /* Check for staff type */
    } elseif (isset($list['type']) and $list['type'] == 'staff') {
        ${'leftLists' . $leftListsCounter}['type'] = $list['type'] ?? null;
        ${'leftLists' . $leftListsCounter}['headline'] = $list['headline'] ?? null;
        ${'leftLists' . $leftListsCounter}['listurl'] = $list['listurl'] ?? null;
        ${'leftLists' . $leftListsCounter}['readmore'] = $list['readmore'] ?? null;
        ${'leftLists' . $leftListsCounter}['format'] = $list['format'] ?? null;
        ${'leftLists' . $leftListsCounter}['staffers'] = returnStaffLists($list['query'], $list['count'], $list['start'])['staffers'];
    } elseif (isset($list['type']) and $list['type'] == 'list') {
        ${'leftLists' . $leftListsCounter}['headline'] = $list['headline'] ?? null;
        ${'leftLists' . $leftListsCounter}['listurl'] = $list['listurl'] ?? null;
        ${'leftLists' . $leftListsCounter}['readmore'] = $list['readmore'] ?? null;
        ${'leftLists' . $leftListsCounter}['format'] = $list['format'] ?? null;
        ${'leftLists' . $leftListsCounter}['section_label'] = $list['section_label'] ?? null;
        ${'leftLists' . $leftListsCounter}['more_articles'] = $list['more_articles'] ?? [];
        if (isset($list['pagenum'])) {
            ${'leftLists' . $leftListsCounter}['pagenum'] = $list['pagenum'];
        }
        if (isset($list['query']) && isset($list['count']) && isset($list['start'])) {
            if (isset($list['pagination']) && $list['pagination']) {
                $queryStart = $list['start'] + ($list['count'] * ($list['pagenum'] - 1));
            } else {
                $queryStart = $list['start'];
            }
            $query = returnFullArticleLists($list['query'], $list['count'], $queryStart);

            ${'leftLists' . $leftListsCounter}['articles'] = $query['articles'];
            ${'leftLists' . $leftListsCounter}['hits'] = $query['hits'];
            /* Add article uuid to noDuplicatesArray */
            foreach (${'leftLists' . $leftListsCounter}['articles'] as $article) {
                array_push($noDuplicatesArray, $article['uuid']);
            }
        } else {
            ${'leftLists' . $leftListsCounter}['articles'] = null;
        }
    } else {
        ${'leftLists' . $leftListsCounter}['headline'] = $list['headline'] ?? null;
        ${'leftLists' . $leftListsCounter}['listurl'] = $list['listurl'] ?? null;
        ${'leftLists' . $leftListsCounter}['readmore'] = $list['readmore'] ?? null;
        ${'leftLists' . $leftListsCounter}['format'] = $list['format'] ?? null;
        ${'leftLists' . $leftListsCounter}['section_label'] = $list['section_label'] ?? null;
        ${'leftLists' . $leftListsCounter}['more_articles'] = $list['more_articles'] ?? [];
        if (isset($list['pagenum'])) {
            ${'leftLists' . $leftListsCounter}['pagenum'] = $list['pagenum'];
        }
        if (isset($list['query']) && isset($list['count']) && isset($list['start'])) {
            if (isset($list['pagination']) && $list['pagination']) {
                $queryStart = $list['start'] + ($list['count'] * ($list['pagenum'] - 1));
            } else {
                $queryStart = $list['start'];
            }
            //$query = return_Query_With_NoDuplicates($list['query'], $noDuplicatesArray);
            $query = returnArticleLists($list['query'], $list['count'], $queryStart);
            ${'leftLists' . $leftListsCounter}['articles'] = $query['articles'];
            ${'leftLists' . $leftListsCounter}['hits'] = $query['hits'];
            /* Add article uuid to noDuplicatesArray */
            foreach (${'leftLists' . $leftListsCounter}['articles'] as $article) {
                array_push($noDuplicatesArray, $article['uuid']);
            }
        } else {
            ${'leftLists' . $leftListsCounter}['articles'] = null;
        }
    }
    ${'leftLists' . $leftListsCounter}['template'] = $list['template'] ?? null;
    $leftListsCounter++;
}

/* Build Right Lists Array */
if (isset($rightListsArray)) {
    $rightListsCounter = 1;
    foreach ($rightListsArray as $list) {
        ${'rightLists' . $rightListsCounter} = array();
        /* Check for adspot type */
        if (isset($list['type']) and $list['type'] == 'adspot') {
            ${'rightLists' . $rightListsCounter}['type'] = $list['type'] ?? null;
            ${'rightLists' . $rightListsCounter}['width'] = $list['width'] ?? null;
            ${'rightLists' . $rightListsCounter}['adcode'] = $list['adcode'] ?? null;
            ${'rightLists' . $rightListsCounter}['provider'] = $list['provider'] ?? null;
            /* Check for column type */
        } elseif (isset($list['type']) and $list['type'] == 'column') {
            ${'rightLists' . $rightListsCounter}['type'] = $list['type'] ?? null;
            ${'rightLists' . $rightListsCounter}['headline'] = $list['headline'] ?? null;
            ${'rightLists' . $rightListsCounter}['listurl'] = $list['listurl'] ?? null;
            ${'rightLists' . $rightListsCounter}['readmore'] = $list['readmore'] ?? null;
            ${'rightLists' . $rightListsCounter}['format'] = $list['format'] ?? null;
            ${'rightLists' . $rightListsCounter}['articles'] = returnArticleLists($list['query'], $list['count'], $list['start'])['articles'];
            /* Insert columnist image uuid into article array */
            foreach (${'rightLists' . $rightListsCounter}['articles'] as $article) {
                $authors = $article['authors'];
                foreach ($authors as $author) {
                    $authorquery = 'uuid:' . $author['uuid'];
                    $authordata = returnAuthordata($authorquery);
                    ${'rightLists' . $rightListsCounter}['articles'][0]['author_imageuuid'] = $authordata[0]['image_uuids'][0];
                }
            }
            /* Check for mostread type */
        } elseif (isset($list['type']) and $list['type'] == 'mostread') {
            ${'rightLists' . $rightListsCounter}['type'] = $list['type'] ?? null;
            ${'rightLists' . $rightListsCounter}['headline'] = $list['headline'] ?? null;
            ${'rightLists' . $rightListsCounter}['listurl'] = $list['listurl'] ?? null;
            ${'rightLists' . $rightListsCounter}['readmore'] = $list['readmore'] ?? null;
            ${'rightLists' . $rightListsCounter}['count'] = $list['count'] ?? null;
            ${'rightLists' . $rightListsCounter}['start'] = $list['start'] ?? null;
            ${'rightLists' . $rightListsCounter}['view_id'] = $list['view_id'] ?? null;
            ${'rightLists' . $rightListsCounter}['template'] = $list['template'] ?? null;
            /* Check for staff type */
        } elseif (isset($list['type']) and $list['type'] == 'staff') {
            ${'rightLists' . $rightListsCounter}['type'] = $list['type'] ?? null;
            ${'rightLists' . $rightListsCounter}['headline'] = $list['headline'] ?? null;
            ${'rightLists' . $rightListsCounter}['listurl'] = $list['listurl'] ?? null;
            ${'rightLists' . $rightListsCounter}['readmore'] = $list['readmore'] ?? null;
            ${'rightLists' . $rightListsCounter}['format'] = $list['format'] ?? null;
            ${'rightLists' . $rightListsCounter}['staffers'] = returnStaffLists($list['query'], $list['count'], $list['start'])['staffers'];
        } elseif (isset($list['type']) and $list['type'] == 'list') {
            ${'rightLists' . $rightListsCounter}['headline'] = $list['headline'] ?? null;
            ${'rightLists' . $rightListsCounter}['listurl'] = $list['listurl'] ?? null;
            ${'rightLists' . $rightListsCounter}['readmore'] = $list['readmore'] ?? null;
            ${'rightLists' . $rightListsCounter}['format'] = $list['format'] ?? null;
            ${'rightLists' . $rightListsCounter}['articles'] = returnFullArticleLists($list['query'], $list['count'], $list['start'])['articles'];
            /* Add article uuid to noDuplicatesArray */
            foreach (${'rightLists' . $rightListsCounter}['articles'] as $article) {
                array_push($noDuplicatesArray, $article['uuid']);
            }
        } else {
            ${'rightLists' . $rightListsCounter}['headline'] = $list['headline'] ?? null;
            ${'rightLists' . $rightListsCounter}['listurl'] = $list['listurl'] ?? null;
            ${'rightLists' . $rightListsCounter}['readmore'] = $list['readmore'] ?? null;
            ${'rightLists' . $rightListsCounter}['format'] = $list['format'] ?? null;
            //$query = return_Query_With_NoDuplicates($list['query'], $noDuplicatesArray);
            ${'rightLists' . $rightListsCounter}['articles'] = returnArticleLists($list['query'], $list['count'], $list['start'])['articles'];
            /* Add article uuid to noDuplicatesArray */
            foreach (${'rightLists' . $rightListsCounter}['articles'] as $article) {
                array_push($noDuplicatesArray, $article['uuid']);
            }
        }
        ${'rightLists' . $rightListsCounter}['template'] = $list['template'] ?? null;
        $rightListsCounter++;
    }
}